﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using IL2Modder.IL2;

namespace IL2Modder
{
    public partial class FlipNormals : Form
    {
        Mesh target;

        public FlipNormals(Mesh mesh)
        {
            InitializeComponent();
            target = mesh;
            mesh.CacheNormals();
        }


        private void button1_Click(object sender, EventArgs e)
        {
            target.RecoverNormals();
            this.Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked)
            {
                checkBox2.Checked = false;
                checkBox3.Checked = false;
                target.FlipNormals(0);
            }
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox2.Checked)
            {
                checkBox1.Checked = false;
                checkBox3.Checked = false;
                target.FlipNormals(1);
            }
        }

        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox3.Checked)
            {
                checkBox2.Checked = false;
                checkBox1.Checked = false;
                target.FlipNormals(2);
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            target.FlipNormals(3);
        }

        /// <summary>
        /// Recalculate all the normals
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button4_Click(object sender, EventArgs e)
        {
            target.RecalculateNormals();
        }
    }
}
